<template>
   <div class="app-container">
      <el-form :model="queryParams" ref="queryRef" v-show="showSearch" :inline="true" label-width="68px">
         <el-form-item label="项目名称" prop="projectName">
            <el-input
               v-model="queryParams.projectName"
               placeholder="请输入项目名称"
               clearable
               style="width: 240px"
               @keyup.enter="handleQuery"
            />
         </el-form-item>
         <el-form-item label="状态" prop="status">
            <el-select
               v-model="queryParams.status"
               placeholder="项目状态"
               clearable
               style="width: 240px"
            >
               <el-option
                  v-for="dict in sys_status"
                  :key="dict.value"
                  :label="dict.label"
                  :value="dict.value"
               />
            </el-select>
         </el-form-item>
         <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
           <el-button type="primary" plain icon="Plus" @click="handleAdd">新增</el-button>
         </el-form-item>
      </el-form>

      <!-- 表格数据 -->
      <el-table v-loading="loading" :data="projectList">
        <el-table-column label="项目LOGO" align="center">
          <template #default="scope">
            <el-image
                v-if="scope.row.logoUrl"
                style="width: 40px; height: 40px; border-radius: 4px"
                :src="scope.row.logoUrl"
                :preview-src-list="[scope.row.logoUrl]"
                fit="cover"
                preview-teleported
            >
              <template #error>
                <div class="image-slot">
                  <el-icon><Picture /></el-icon>
                </div>
              </template>
            </el-image>
            <span v-else>无LOGO</span>
          </template>
        </el-table-column>
        <el-table-column label="项目名称" prop="projectName" />
        <el-table-column prop="scope" label="作用域">
          <template #default="scope">
          <dict-tag :options="sys_scope" :value="scope.row.scope" />
          </template>
        </el-table-column>
        <el-table-column label="所属租户名称" prop="tenantName" />
        <el-table-column prop="isIn" label="是否内置项目">
          <template #default="scope">
            <dict-tag :options="sys_no_yes" :value="scope.row.isIn" />
          </template>
        </el-table-column>
        <el-table-column label="状态" align="center">
          <template #default="scope">
            <el-switch
                v-model="scope.row.status"
                :active-value="1"
                :inactive-value="0"
                @change="(val) => handleStatusChange(scope.row, $event)"
            ></el-switch>
          </template>
        </el-table-column>
        <el-table-column label="项目开始时间" align="center" prop="startTime">
          <template #default="scope">
            <span>{{ parseTime(scope.row.startTime) }}</span>
          </template>
        </el-table-column>
        <el-table-column label="项目结束时间" align="center" prop="endTime">
          <template #default="scope">
            <span>{{ parseTime(scope.row.endTime) }}</span>
          </template>
        </el-table-column>
         <el-table-column label="操作" align="center" class-name="small-padding fixed-width" width="200px">
            <template #default="scope">
              <el-button link type="primary" icon="Edit" @click="handlePermission(scope.row)" >分配权限</el-button>
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" >修改</el-button>
<!--              <el-button link type="primary" icon="View" @click="handleUpdate(scope.row)" >详情</el-button>-->
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" >删除</el-button>
            </template>
         </el-table-column>
      </el-table>

      <pagination
         v-show="total > 0"
         :total="total"
         v-model:page="queryParams.pageNum"
         v-model:limit="queryParams.pageSize"
         @pagination="getList"
      />

      <!-- 添加或修改项目对话框 -->
      <el-dialog :title="title" v-model="open" width="600px" append-to-body>
         <el-form ref="projectRef" :model="form" :rules="rules" label-width="120px">
            <el-form-item label="项目名称" prop="projectName">
               <el-input v-model="form.projectName" placeholder="请输入项目名称" />
            </el-form-item>
            <el-form-item label="项目开始时间" prop="startTime">
             <el-date-picker
                 v-model="form.startTime"
                 type="datetime"
                 placeholder="选择项目开始时间"
                 value-format="YYYY-MM-DD HH:mm:ss"
                 style="width: 100%"
             />
            </el-form-item>
            <el-form-item label="项目结束时间" prop="endTime">
             <el-date-picker
                 v-model="form.endTime"
                 type="datetime"
                 placeholder="选择项目结束时间"
                 value-format="YYYY-MM-DD HH:mm:ss"
                 style="width: 100%"
             />
            </el-form-item>
            <el-form-item label="是否内置项目">
             <el-radio-group v-model="form.isIn">
               <el-radio
                   v-for="dict in sys_no_yes"
                   :key="Number(dict.value)"
                   :value="Number(dict.value)">
                 {{ dict.label }}
               </el-radio>
             </el-radio-group>
            </el-form-item>
            <el-form-item label="项目访问地址" prop="projectUrl">
             <el-input v-model="form.projectUrl" placeholder="请输入项目访问地址" />
            </el-form-item>
           <!-- 作用域选择 -->
           <el-form-item label="作用域">
             <el-radio-group v-model="form.scope" @change="handleScopeChange">
               <el-radio
                   v-for="dict in filteredScopeOptions"
                   :key="Number(dict.value)"
                   :value="Number(dict.value)"
               >
                 {{ dict.label }}
               </el-radio>
             </el-radio-group>
           </el-form-item>

           <!-- 所属租户 - 可搜索下拉框 -->
           <el-form-item
               v-if="[2].includes(form.scope)"
               label="所属租户"
               prop="tenantBizId"
           >
             <el-select
                 v-model="form.tenantBizId"
                 filterable
                 remote
                 reserve-keyword
                 placeholder="请输入关键词搜索租户"
                 :remote-method="searchTenants"
                 :loading="tenantLoading"
             >
               <el-option
                   v-for="item in tenantOptions"
                   :key="item.tenantBizId"
                   :label="item.tenantName"
                   :value="item.tenantBizId"
               />
             </el-select>
           </el-form-item>

           <!-- 所属项目 - 可搜索下拉框 -->
           <el-form-item
               v-if="[3].includes(form.scope)"
               label="所属项目"
               prop="projectBizId"
           >
             <el-select
                 v-model="form.projectBizId"
                 filterable
                 remote
                 reserve-keyword
                 placeholder="请输入关键词搜索项目"
                 :remote-method="searchProjects"
                 :loading="projectLoading"
             >
               <el-option
                   v-for="item in projectOptions"
                   :key="item.projectBizId"
                   :label="item.projectName"
                   :value="item.projectBizId"
               />
             </el-select>
           </el-form-item>
            <el-form-item label="项目描述">
               <el-input v-model="form.description" type="textarea" placeholder="请输入项目描述"></el-input>
            </el-form-item>
           <el-form-item label="状态">
             <el-radio-group v-model="form.status">
               <el-radio
                   v-for="dict in sys_status"
                   :key="Number(dict.value)"
                   :value="Number(dict.value)">
                 {{ dict.label }}
               </el-radio>
             </el-radio-group>
           </el-form-item>
            <el-form-item label="项目图标" prop="logoUrl">
             <el-input v-model="form.logoUrl" placeholder="请输入项目图标" />
            </el-form-item>
         </el-form>
         <template #footer>
            <div class="dialog-footer">
               <el-button type="primary" @click="submitForm">确 定</el-button>
               <el-button @click="cancel">取 消</el-button>
            </div>
         </template>
      </el-dialog>

      <!-- 分配角色数据权限对话框 -->
      <el-dialog :title="title" v-model="openDataScope" width="500px" append-to-body>
         <el-form :model="form" label-width="80px">
            <el-form-item label="角色名称">
               <el-input v-model="form.roleName" :disabled="true" />
            </el-form-item>
            <el-form-item label="权限字符">
               <el-input v-model="form.roleKey" :disabled="true" />
            </el-form-item>
            <el-form-item label="权限范围">
               <el-select v-model="form.dataScope" @change="dataScopeSelectChange">
                  <el-option
                     v-for="item in dataScopeOptions"
                     :key="item.value"
                     :label="item.label"
                     :value="item.value"
                  ></el-option>
               </el-select>
            </el-form-item>
            <el-form-item label="数据权限" v-show="form.dataScope == 2">
               <el-checkbox v-model="deptExpand" @change="handleCheckedTreeExpand($event, 'dept')">展开/折叠</el-checkbox>
               <el-checkbox v-model="deptNodeAll" @change="handleCheckedTreeNodeAll($event, 'dept')">全选/全不选</el-checkbox>
               <el-checkbox v-model="form.deptCheckStrictly" @change="handleCheckedTreeConnect($event, 'dept')">父子联动</el-checkbox>
               <el-tree
                  class="tree-border"
                  :data="deptOptions"
                  show-checkbox
                  default-expand-all
                  ref="deptRef"
                  node-key="id"
                  :check-strictly="!form.deptCheckStrictly"
                  empty-text="加载中，请稍候"
                  :props="{ label: 'label', children: 'children' }"
               ></el-tree>
            </el-form-item>
         </el-form>
         <template #footer>
            <div class="dialog-footer">
               <el-button type="primary" @click="submitDataScope">确 定</el-button>
               <el-button @click="cancelDataScope">取 消</el-button>
            </div>
         </template>
      </el-dialog>
   </div>
</template>

<script setup name="Project">

import { computed } from 'vue'

import { addProject, changeRoleStatus, dataScope, delRole, getProject, listProject, updateProject, deptTreeSelect,searchScopeList,changeProjectStatus } from "@/api/system/project"
import { roleMenuTreeselect, treeselect as menuTreeselect } from "@/api/system/menu"
import useUserStore from '@/store/modules/user'
import {formatIsoToDateTime} from '@/utils/date'

const userStore = useUserStore()
const router = useRouter()
const { proxy } = getCurrentInstance()
const { sys_status,sys_scope,sys_no_yes } = proxy.useDict("sys_status","sys_scope","sys_no_yes")

const projectList = ref([])
const open = ref(false)
const loading = ref(true)
const showSearch = ref(true)
const ids = ref([])
const single = ref(true)
const multiple = ref(true)
const total = ref(0)
const title = ref("")
const dateRange = ref([])
const menuOptions = ref([])
const menuExpand = ref(false)
const menuNodeAll = ref(false)
const deptExpand = ref(true)
const deptNodeAll = ref(false)
const deptOptions = ref([])
const openDataScope = ref(false)
const menuRef = ref(null)
const deptRef = ref(null)

/** 数据范围选项*/
const dataScopeOptions = ref([
  { value: "1", label: "全部数据权限" },
  { value: "2", label: "自定数据权限" },
  { value: "3", label: "本部门数据权限" },
  { value: "4", label: "本部门及以下数据权限" },
  { value: "5", label: "仅本人数据权限" }
])

const data = reactive({
  form: {
    scope: 1
  },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    loginTenantBizId: userStore.currentTenant.apiLoginTenantInfoResponse.tenantBizId,
    projectName: undefined,
    status: undefined
  },
  rules: {
    projectName: [{ required: true, message: "项目名称不能为空", trigger: "blur" }],
    status: [{ required: true, message: "状态不能为空", trigger: "blur" }],
    startTime: [{ required: true, message: "项目开始时间不能为空", trigger: "blur" }],
    endTime: [{ required: true, message: "项目结束时间不能为空", trigger: "blur" }],
    scope: [{ required: true, message: "作用域不能为空", trigger: "blur" }],
    logoUrl: [{ required: true, message: "项目图标地址不能为空", trigger: "blur" }],
    isIn: [{ required: true, message: "是否内置项目不能为空", trigger: "blur" }],
  }
})

const filteredScopeOptions = computed(() => {
  if (!sys_scope.value || !Array.isArray(sys_scope.value)) return []

  return sys_scope.value.filter(option => {
    // 添加安全判断
    if (!option || typeof option.value === 'undefined') return false
    return Number(option.value) !== 3
  })
})

const { queryParams, form, rules } = toRefs(data)

/** 查询项目列表 */
function getList() {
  loading.value = true
  listProject(queryParams.value).then(response => {
    projectList.value = response.data.records
    total.value = response.data.total
    loading.value = false
  })
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1
  getList()
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef")
  handleQuery()
}

/** 删除按钮操作 */
function handleDelete(row) {
  const roleIds = row.roleId || ids.value
  proxy.$modal.confirm('是否确认删除角色编号为"' + roleIds + '"的数据项?').then(function () {
    return delRole(roleIds)
  }).then(() => {
    getList()
    proxy.$modal.msgSuccess("删除成功")
  }).catch(() => {})
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download("system/role/export", {
    ...queryParams.value,
  }, `role_${new Date().getTime()}.xlsx`)
}

/** 多选框选中数据 */
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.roleId)
  single.value = selection.length != 1
  multiple.value = !selection.length
}

/** 项目状态修改 */
function handleStatusChange(row, event) {
  let text = row.status === 0 ? "停用" : "启用"
  const projectName = row.projectName
  proxy.$modal.confirm(`确认要${text}"${projectName}"项目吗?`)
      .then(() => changeProjectStatus({projectBizId: row.projectBizId, status: row.status}))
      .then(() => proxy.$modal.msgSuccess(`${text}成功`))
      .catch(() => {
        // 操作取消时恢复原状态
        row.status = row.status === 0 ? 1 : 0
      })
}

/** 更多操作 */
function handleCommand(command, row) {
  switch (command) {
    case "handleDataScope":
      handleDataScope(row)
      break
    case "handleAuthUser":
      handleAuthUser(row)
      break
    default:
      break
  }
}

/** 分配权限 */
function handlePermission(row) {
  router.push(`/system/project/permission?projectBizId=` + row.projectBizId)
}

/** 所有部门节点数据 */
function getDeptAllCheckedKeys() {
  // 目前被选中的部门节点
  let checkedKeys = deptRef.value.getCheckedKeys()
  // 半选中的部门节点
  let halfCheckedKeys = deptRef.value.getHalfCheckedKeys()
  checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
  return checkedKeys
}

/** 重置新增的表单以及其他数据  */
function reset() {
  form.value = {
    projectBizId: undefined,
    projectName: undefined,
    description: undefined,
    status: 1,
    startTime: undefined,
    endTime: undefined,
    scope: 1,
    tenantBizId: undefined,
    logoUrl: undefined,
    isIn: 0,
    projectUrl: undefined
  }
  proxy.resetForm("projectRef")
}

/** 添加项目 */
function handleAdd() {
  reset()
  open.value = true
  title.value = "添加项目"
}

/** 修改项目 */
function handleUpdate(row) {
  reset()
  const projectBizId = row.projectBizId
  getProject(projectBizId).then(response => {
    const resData = response.data;
    form.value = {
      ...resData,
      startTime: formatIsoToDateTime(resData.startTime),
      endTime: formatIsoToDateTime(resData.endTime)
    };
    // 根据作用域类型预加载关联数据
    if (resData.scope === 2) {
      tenantOptions.value.push({
        tenantBizId: resData.tenantBizId,
        tenantName: resData.tenantName
      });
    }
    open.value = true
  })
  title.value = "修改项目"
}

/** 根据角色ID查询菜单树结构 */
function getProjectMenuTreeselect(roleId) {
  return roleMenuTreeselect(roleId).then(response => {
    menuOptions.value = response.menus
    return response
  })
}

/** 根据角色ID查询部门树结构 */
function getDeptTree(roleId) {
  return deptTreeSelect(roleId).then(response => {
    deptOptions.value = response.depts
    return response
  })
}

/** 树权限（展开/折叠）*/
function handleCheckedTreeExpand(value, type) {
  if (type == "menu") {
    let treeList = menuOptions.value
    for (let i = 0; i < treeList.length; i++) {
      menuRef.value.store.nodesMap[treeList[i].id].expanded = value
    }
  } else if (type == "dept") {
    let treeList = deptOptions.value
    for (let i = 0; i < treeList.length; i++) {
      deptRef.value.store.nodesMap[treeList[i].id].expanded = value
    }
  }
}

/** 树权限（全选/全不选） */
function handleCheckedTreeNodeAll(value, type) {
  if (type == "menu") {
    menuRef.value.setCheckedNodes(value ? menuOptions.value : [])
  } else if (type == "dept") {
    deptRef.value.setCheckedNodes(value ? deptOptions.value : [])
  }
}

/** 树权限（父子联动） */
function handleCheckedTreeConnect(value, type) {
  if (type == "menu") {
    form.value.menuCheckStrictly = value ? true : false
  } else if (type == "dept") {
    form.value.deptCheckStrictly = value ? true : false
  }
}

/** 所有菜单节点数据 */
function getMenuAllCheckedKeys() {
  // 目前被选中的菜单节点
  let checkedKeys = menuRef.value.getCheckedKeys()
  // 半选中的菜单节点
  let halfCheckedKeys = menuRef.value.getHalfCheckedKeys()
  checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys)
  return checkedKeys
}

/** 添加和修改项目提交按钮 */
function submitForm() {
  proxy.$refs["projectRef"].validate(valid => {
    if (valid) {
      if (form.value.projectBizId) {
        updateProject(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功")
          open.value = false
          getList()
        })
      } else {
        addProject(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功")
          open.value = false
          getList()
        })
      }
    }
  })
}

/** 取消按钮 */
function cancel() {
  open.value = false
  reset()
}

/** 选择角色权限范围触发 */
function dataScopeSelectChange(value) {
  if (value !== "2") {
    deptRef.value.setCheckedKeys([])
  }
}

/** 分配数据权限操作 */
function handleDataScope(row) {
  reset()
  const deptTreeSelect = getDeptTree(row.roleId)
  getProject(row.roleId).then(response => {
    form.value = response.data
    openDataScope.value = true
    nextTick(() => {
      deptTreeSelect.then(res => {
        nextTick(() => {
          if (deptRef.value) {
            deptRef.value.setCheckedKeys(res.checkedKeys)
          }
        })
      })
    })
  })
  title.value = "分配数据权限"
}

/** 提交按钮（数据权限） */
function submitDataScope() {
  if (form.value.roleId != undefined) {
    form.value.deptIds = getDeptAllCheckedKeys()
    dataScope(form.value).then(response => {
      proxy.$modal.msgSuccess("修改成功")
      openDataScope.value = false
      getList()
    })
  }
}

/** 取消按钮（数据权限）*/
function cancelDataScope() {
  openDataScope.value = false
  reset()
}


//========作用域-切换逻辑开始=========
const tenantOptions = ref([])
const tenantLoading = ref(false)
const projectOptions = ref([])
const projectLoading = ref(false)
// 作用域变更处理
function handleScopeChange(val) {
  console.log('作用域变更:', val);

  // 清空不需要的字段值
  if (val === 2) {
    form.value.projectBizId = '';
    // 自动加载租户列表（可选）
    searchTenants('');
  } else if (val === 3) {
    form.value.tenantBizId = '';
    // 自动加载项目列表（可选）
    searchProjects('');
  } else if (val === 1) {
    //系统级
    form.value.tenantBizId = '';
    form.value.projectBizId = '';
  }
}

// 搜索租户方法
function searchTenants(query) {
  tenantLoading.value = true;
  try {
    const params = {
      loginTenantBizId: userStore.currentTenant.apiLoginTenantInfoResponse.tenantBizId,
      scope: 2,name: query, pageNo:1, pageSize: 10 };

    searchScopeList(params).then(response => {
      tenantOptions.value = response.data.records
    })
  } catch (error) {
    console.error('租户搜索失败', error);
    tenantOptions.value = [];
  } finally {
    tenantLoading.value = false;
  }
}

// 搜索项目方法
function searchProjects(query) {
  projectLoading.value = true;
  try {
    const params = {
      loginTenantBizId: userStore.currentTenant.apiLoginTenantInfoResponse.tenantBizId,
      scope: 3,name: query, pageNo:1, pageSize: 10 };
    searchScopeList(params).then(response => {
      projectOptions.value = response.data.records
    })
  } catch (error) {
    console.error('项目搜索失败', error);
    projectOptions.value = [];
  } finally {
    projectLoading.value = false;
  }
}
//========作用域-切换逻辑结束=========

getList()
</script>
